### Resources when setting up project

* Using archtype : I have used `quickstart` one
* [A `.gitignore` file suitable for development with `Java`, `Maven`, `Gradle`, `IntelliJ`, `Android Studio` on a `MacOS`](https://gist.github.com/edesdan/6bb43343740bcd54ef0f56a384a2f66f)
* Had issues with github, as this `.git` tool was creating commits on anonymous user's behalf, <br/>
  had to add `user configuration` to the `config` file og `.git`
* [Which files in `.idea` folder should be tracked by Git?](https://stackoverflow.com/questions/43198273/which-files-in-idea-folder-should-be-tracked-by-git)
* [How to configure `Grep Console` for Intellij](https://stackoverflow.com/questions/24430340/how-to-configure-grep-console-for-intellij)
* [Git: Renaming the `master` branch to `main`](https://dev.to/rhymu8354/git-renaming-the-master-branch-137b)
* [Intellij IDEA Tutorial: Projects and modules overview](https://www.youtube.com/watch?v=IGgED_ihY5c&ab_channel=CraftOfProgramming)
* [Multi-Module Project With Spring Boot | Maven | Example | Java Techie](https://www.youtube.com/watch?v=DG9B2w-N42s&ab_channel=JavaTechie)
* [IntelliJ Workspace Tips - Multiple Repositories in One Workspace](https://www.youtube.com/watch?v=9pRf3VRXEdo&ab_channel=SpringFrameworkGuru)
* [IntelliJ Workspace Tips - Multiple Repositories (microservices) in One Workspace](https://www.youtube.com/watch?v=9pRf3VRXEdo&ab_channel=SpringFrameworkGuru)
* [How to Work with Multiple Project Repos in IntelliJ](https://www.youtube.com/watch?v=mToyuBV_ydw&ab_channel=TestOxide)

### Clean Code

* [Install and Use CheckStyle for Java as an IntelliJ IDEA Plugin 2018](https://www.youtube.com/watch?v=RAC_VRj2bcM&ab_channel=EvilTester-SoftwareTesting)
* [CodeReview Plugin in Eclipse | SonarLint | PMD | Checkstyle](https://www.youtube.com/watch?v=WGFw1thosCg&ab_channel=ArunaVangala)
* [CheckStyle || Maven || Configuration|| HTML Report - 1](https://www.youtube.com/watch?v=aSCUyUuPHuM&ab_channel=SlokamTechnologies)
* [CheckStyle || Rules, Suppressions || Fixing Code Errors - 2](https://www.youtube.com/watch?v=rlLz9ftmWTY&ab_channel=SlokamTechnologies)
* [What is SonarQube? How to configure a maven project for Code Coverage | Tech Primers](https://www.youtube.com/watch?v=BuT1Ji0P9Ug&ab_channel=TechPrimers)
* [What is SonarQube?](https://www.youtube.com/watch?v=vE39Fg8pvZg&ab_channel=HenrikYllemo)
* [SonarQube Tutorial | Installing and Configuring SonarQube | What is SonarQube | Intellipaat](https://www.youtube.com/watch?v=31igoWxauEQ&ab_channel=Intellipaat)
* [Introduction to CheckStyle - Baeldung](https://www.baeldung.com/checkstyle-java)
* [How to Centralize your Checkstyle Configuration with Maven](https://codeburst.io/how-to-centralize-your-checkstyle-configuration-with-maven-7575eacd7295)
  Great Solution <br>
  - Externalizing his own version of checkstyle
    config [Common Checkstyle Config](https://github.com/patrickfav/checkstyle-config/)
* [Install and Use CheckStyle for Java as an IntelliJ IDEA Plugin 2018](https://www.youtube.com/watch?v=RAC_VRj2bcM&ab_channel=EvilTester-SoftwareTesting)

#### checkStyle

* [Google's Java Style Checkstyle Coverage](https://checkstyle.sourceforge.io/google_style.html)
* [google_checks.xml](https://github.com/checkstyle/checkstyle/blob/master/src/main/resources/google_checks.xml)
* [IntelliJ IDEA code format from checkstyle configuration](https://stackoverflow.com/questions/14539313/intellij-idea-code-format-from-checkstyle-configuration)
* [How to import checkstyle rules into Intellij IDEA code format rules](http://biercoff.com/how-to-import-checkstyle-rules-into-intellij-idea-code-format-rules/)
* [checkstyle:check](https://maven.apache.org/plugins/maven-checkstyle-plugin/check-mojo.html) - To add checkstyle for
  test directory as well

#### JaCoCo

* [Intro to JaCoCo - Baeldung](https://www.baeldung.com/jacoco)

#### SonarQube

* [Code Analysis with SonarQube](https://www.baeldung.com/sonar-qube)
* [Configuring a Project to Exclude Certain Sonar Violations](https://www.baeldung.com/sonar-exclude-violations)

### Resource for Object Oriented Design

* [oodesign.com](https://www.oodesign.com/)
* [Java Design Pattern `Open Sourced`](https://java-design-patterns.com/)

### Extra

* [Subhrodip Mohanta - Github Profile](https://github.com/ohbus)
  - Indian In Wipro
  - Have some cool projects
  - Banking
  - Design pattern

#### Plant UML

* [Cant render component diagram in plantuml intllij - StackOverFlow](https://stackoverflow.com/questions/54413962/cant-render-component-diagram-in-plantuml-intllij)
* [GraphViz - Installing](https://plantuml.com/graphviz-dot)
* [Welcome to The Hitchhiker’s Guide to PlantUML!](https://crashedmind.github.io/PlantUMLHitchhikersGuide/)
* [Sketch It!  - Plant UML Tool](https://plugins.jetbrains.com/plugin/10387-sketch-it-)

#### Some Useful Things

* To delete all the **.plantuml** file `find src -type f -name "*.plantuml" -delete`
* To delete all the **.class** file `find src -type f -name "*.class" -delete`